<template>
  <v-card>
    <v-toolbar dense>
      <v-toolbar-title>
        Добавить метод платежа
      </v-toolbar-title>
    </v-toolbar>
    <v-container>
      <v-row>
        <v-col cols="12">
          <v-text-field
            v-mask="'#### #### #### ####'"
            v-model="card"
            hide-details
            placeholder="5578 5578 5578 5578"
          />
        </v-col>
        <v-col cols="12">
          <v-select
            v-model="bank"
            :items="banks"
            placeholder="Выберите банк"
            hide-details
          />
        </v-col>
        <v-col cols="12">
          <v-text-field v-model="lastName" placeholder="Фамилия" hide-details />
        </v-col>
        <v-col cols="12">
          <v-text-field v-model="firstName" placeholder="Имя" hide-details />
        </v-col>
        <v-col cols="12">
          <v-text-field
            v-model="patronymic"
            placeholder="Отчество"
            hide-details
          />
        </v-col>
        <v-col cols="12">
          <v-btn color="primary" block @click="ensure" :disabled="disabled">
            <v-icon>mdi-plus</v-icon>
            Добавить
          </v-btn>
        </v-col>
      </v-row>
    </v-container>
  </v-card>
</template>

<script lang="ts">
import { BankDetailsEnsureExistsCommand } from '@/api/ledius-token/api';
import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';

@Component({})
export default class BankDetailsForm extends Vue {
  @Prop({
    required: true,
    type: String
  })
  private readonly userId!: string;

  private disabled: boolean = false;

  private readonly card: string = '';
  private readonly bank: string = '';
  private readonly firstName: string = '';
  private readonly lastName: string = '';
  private readonly patronymic: string = '';

  private get banks(): Record<string, string>[] {
    return [
      { text: 'Сбербанк', value: 'Сбербанк' },
      { text: 'Альфа-Банк', value: 'Альфа-Банк' },
      { text: 'Тинькофф', value: 'Тинькофф' },
      { text: 'ВТБ', value: 'ВТБ' }
    ];
  }

  private async ensure(): Promise<void> {
    try {
      this.disabled = true;
      await this.$store.dispatch('exchange/bankDetails/ensure', {
        userId: this.userId,
        bank: this.bank,
        patronymic: this.patronymic,
        lastName: this.lastName,
        firstName: this.firstName,
        card: this.card
      } as BankDetailsEnsureExistsCommand);
    } finally {
      this.disabled = false;
    }
  }
}
</script>

<style scoped></style>
